package Class::ISA;
require 5;
use strict;
use vars qw($Debug $VERSION);
$VERSION = 0.32;
$Debug = 0 unless defined $Debug;

sub self_and_super_versions {
  no strict 'refs';
  map {
        $_ => (defined(${"$_\::VERSION"}) ? ${"$_\::VERSION"} : undef)
      } self_and_super_path($_[0])
}

sub super_path {
  my @ret = &self_and_super_path(@_);
  shift @ret if @ret;
  return @ret;
}

sub self_and_super_path {
  return () unless @_;

  my @out = ();

  my @in_stack = ($_[0]);
  my %seen = ($_[0] => 1);

  my $current;
  while(@in_stack) {
    next unless defined($current = shift @in_stack) && length($current);
    print "At $current\n" if $Debug;
    push @out, $current;
    no strict 'refs';
    unshift @in_stack,
      map
        { my $c = $_;
          substr($c,0,2) = "main::" if substr($c,0,2) eq '::';
          $seen{$c}++ ? () : $c;
        }
        @{"$current\::ISA"}
    ;
  }
  return @out;
}

1;
